﻿using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Syncfusion.UI.Xaml.Grid.Helpers;
using Syncfusion.UI.Xaml.ScrollAxis;

namespace SelectionDemo
{
    /// <summary>
    /// Used to done the basic operation in SfdataGrid.
    /// </summary>
    public class GridCellSelectionControllerExt : GridCellSelectionController
    {
        public GridCellSelectionControllerExt(SfDataGrid dataGrid) : base (dataGrid)
        {

        }

        protected override void ProcessKeyDown(KeyEventArgs args)
        {
            if (args.Key == Key.Tab)
            {
                int rowIndex, columnIndex;
                if (CurrentCellManager.CurrentRowColumnIndex.RowIndex <= this.DataGrid.GetHeaderIndex() && !(this.DataGrid is DetailsViewDataGrid))
                    return;

                lastPressedKey = Key.Tab;
                var previousCellEditStatus = this.CurrentCellManager.HasCurrentCell ? this.CurrentCellManager.CurrentCell.IsEditing : false;
                var rowColumnIndex = this.CurrentCellManager.CurrentRowColumnIndex;
                if (!args.Handled)
                {
                    rowIndex = CurrentCellManager.CurrentRowColumnIndex.RowIndex;
                    columnIndex = CurrentCellManager.CurrentRowColumnIndex.ColumnIndex;
                    var vaildationHelper = this.DataGrid.GetValidationHelper();
                    var raiseValidateMethod = vaildationHelper.GetType().GetMethod("RaiseRowValidate", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance);
                    var isValidationRaised = raiseValidateMethod.Invoke(vaildationHelper, new object[] { CurrentCellManager.CurrentRowColumnIndex });
                    if (!(bool)isValidationRaised)
                    {
                        args.Handled = true;
                        return;
                    }
                    if (columnIndex == this.DataGrid.Columns.Count)
                    {
                        int index = rowIndex + 1;
                        if (index > this.DataGrid.View.Records.Count)
                            index = 1;
                        rowColumnIndex = new RowColumnIndex(index, 1);
                    }
                    else
                    {
                        rowColumnIndex = new RowColumnIndex(rowIndex, columnIndex + 1);
                    }
                    //var method = this.CurrentCellManager.GetType().GetMethod("ProcessCurrentCellSelection", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance);
                    //var isExecuted = method.Invoke(this.CurrentCellManager, new object[] { rowColumnIndex, ActivationTrigger.Keyboard });
                    this.DataGrid.SelectionController.MoveCurrentCell(rowColumnIndex,true);
                    //if (!(bool)isExecuted)
                    //    return;
                }
            }
            else
            {
                base.ProcessKeyDown(args);
            }
        }
    }
}
